/*******************************************************************************
Copyright (c) 2022, Jan Koester jan.koester@gmx.net
All rights reserved.

Redistribution and use in source and binary forms, with or without
modification, are permitted provided that the following conditions are met:
	* Redistributions of source code must retain the above copyright
	  notice, this list of conditions and the following disclaimer.
	* Redistributions in binary form must reproduce the above copyright
	  notice, this list of conditions and the following disclaimer in the
	  documentation and/or other materials provided with the distribution.
	* Neither the name of the <organization> nor the
	  names of its contributors may be used to endorse or promote products
	  derived from this software without specific prior written permission.

THIS SOFTWARE IS PROVIDED BY THE COPYRIGHT HOLDERS AND CONTRIBUTORS "AS IS" AND
ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE IMPLIED
WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE ARE
DISCLAIMED. IN NO EVENT SHALL <COPYRIGHT HOLDER> BE LIABLE FOR ANY
DIRECT, INDIRECT, INCIDENTAL, SPECIAL, EXEMPLARY, OR CONSEQUENTIAL DAMAGES
(INCLUDING, BUT NOT LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES;
LOSS OF USE, DATA, OR PROFITS; OR BUSINESS INTERRUPTION) HOWEVER CAUSED AND
ON ANY THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT LIABILITY, OR TORT
(INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY OUT OF THE USE OF THIS
SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF SUCH DAMAGE.
*******************************************************************************/

#include <stdlib.h>

extern "C" {

	enum	_Unwind_Reason_Code {
		_URC_NO_REASON = 0 ,
		_URC_FOREIGN_EXCEPTION_CAUGHT = 1 ,
		_URC_FATAL_PHASE2_ERROR = 2 ,
		_URC_FATAL_PHASE1_ERROR = 3 ,
		_URC_NORMAL_STOP = 4 ,
		_URC_END_OF_STACK = 5 ,
		_URC_HANDLER_FOUND = 6 ,
		_URC_INSTALL_CONTEXT = 7 ,
		_URC_CONTINUE_UNWIND = 8
	};

	typedef uintptr_t _Unwind_Word 	__attribute__((__mode__(__unwind_word__)));
	typedef _Unwind_Reason_Code(* _Unwind_Trace_Fn) (struct _Unwind_Context *, void *);

	_Unwind_Reason_Code _Unwind_Backtrace(_Unwind_Trace_Fn trace, void * trace_argument){

	}

	_Unwind_Word _Unwind_GetIP 	( 	struct _Unwind_Context *  		) {

	}

    void * _Unwind_Resume(){
        abort();
    }
    
    void *__gxx_personality_v0=0;

	void *__dynamic_cast (const void *src_ptr,    // object started from
                const void*src_type, // type of the starting object
                const void*dst_type, // desired target type
                ptrdiff_t src2dst) // how src and dst are related
  {

  };
};
