/*******************************************************************************
Copyright (c) 2023, Jan Koester jan.koester@gmx.net
All rights reserved.

Redistribution and use in source and binary forms, with or without
modification, are permitted provided that the following conditions are met:
    * Redistributions of source code must retain the above copyright
      notice, this list of conditions and the following disclaimer.
    * Redistributions in binary form must reproduce the above copyright
      notice, this list of conditions and the following disclaimer in the
      documentation and/or other materials provided with the distribution.
    * Neither the name of the <organization> nor the
      names of its contributors may be used to endorse or promote products
      derived from this software without specific prior written permission.

THIS SOFTWARE IS PROVIDED BY THE COPYRIGHT HOLDERS AND CONTRIBUTORS "AS IS" AND
ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE IMPLIED
WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE ARE
DISCLAIMED. IN NO EVENT SHALL <COPYRIGHT HOLDER> BE LIABLE FOR ANY
DIRECT, INDIRECT, INCIDENTAL, SPECIAL, EXEMPLARY, OR CONSEQUENTIAL DAMAGES
(INCLUDING, BUT NOT LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES;
LOSS OF USE, DATA, OR PROFITS; OR BUSINESS INTERRUPTION) HOWEVER CAUSED AND
ON ANY THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT LIABILITY, OR TORT
(INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY OUT OF THE USE OF THIS
SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF SUCH DAMAGE.
*******************************************************************************/

#include <signal.h>
#include <errno.h>
#include <signal.h>

#include "thread_internal.h"

static struct chain {
	struct chain *next;
} *head, *cur;

static void (*callback)(void *);

static int chainlen;

static void handler(int sig, siginfo_t *si, void *ctx)
{
	// struct chain ch;
	// sys::thread *self = sys::__internal::thread::getins().self();
	// int old_errno = errno;
 //
	// if (chainlen == libc.threads_minus_1) return;
 //
	// sigqueue(self->getPid(), SIGSYNCCALL, (union sigval){0});
 //
	// sem_init(&ch.sem, 0, 0);
	// sem_init(&ch.sem2, 0, 0);
 //
	// while (sem_wait(&chainlock));
	// ch.next = head;
	// head = &ch;
	// if (++chainlen == libc.threads_minus_1)
	// 	sem_post(&chaindone);
	// sem_post(&chainlock);
 //
	// while (sem_wait(&ch.sem));
	// callback(context);
	// sem_post(&ch.sem2);
	// while (sem_wait(&ch.sem));
 //
	// errno = old_errno;
}

extern "C" {
    void __synccall(void (*func)(void *), void *ctx){
	// sys::thread *self = sys::__internal::thread::getins().self();
	// struct sigaction sa;
	// struct chain *next;
	// sigset_t oldmask;
 //
	// if (!libc.threads_minus_1) {
	// 	func(ctx);
	// 	return;
	// }
 //
	// __inhibit_ptc();
 //
	// sys::__internal::__block_all_sigs(&oldmask);
 //
	// sem_init(&chaindone, 0, 0);
	// sem_init(&chainlock, 0, 1);
	// chainlen = 0;
	// head = 0;
	// callback = func;
	// context = ctx;
 //
	// sa.sa_flags = SA_SIGINFO | SA_RESTART;
	// sa.sa_sigaction = handler;
	// sigfillset(&sa.sa_mask);
	// __libc_sigaction(SIGSYNCCALL, &sa, 0);
 //
	// sigqueue(self->getPid(), SIGSYNCCALL, (union sigval){0});
	// while (sem_wait(&chaindone));
 //
	// sa.sa_flags = 0;
	// sa.sa_handler = SIG_IGN;
	// __libc_sigaction(SIGSYNCCALL, &sa, 0);
 //
	// for (cur=head; cur; cur=cur->next) {
	// 	sem_post(&cur->sem);
	// 	while (sem_wait(&cur->sem2));
	// }
	// func(ctx);
 //
	// for (cur=head; cur; cur=next) {
	// 	next = cur->next;
	// 	sem_post(&cur->sem);
	// }
 //
	// sys::__internal::__restore_sigs(&oldmask);
 //
	// __release_ptc();
    }
};
