#include <sys/mman.h>

#include <bits/syscall.h>
#include <bits/sysbits.h>

extern "C" {

    void *mmap (void *addr, size_t length, int prot, int flags, int fd, off_t offset){
        return (void*)syscall6(__NR_mmap, (unsigned long)addr,length,prot,flags, fd, offset);
    };

    int munmap (void *addr, size_t length){
        return syscall2(__NR_munmap,(unsigned long)addr,length);
    };

    int mprotect (void *addr, size_t len, int prot){
        return syscall3(__NR_mprotect,(unsigned long)addr,len,prot);
    };

};
